//
//  ViewController.m
//  selectedIndexPath
//
//  Created by XLsn0w on 16/8/2.
//  Copyright © 2016年 XLsn0w. All rights reserved.
//

#import "ViewController.h"
#import "SelectedCell.h"

@interface ViewController () <UITableViewDataSource, UITableViewDelegate, SelectedCellDelegate>

@property (nonatomic, strong) UITableView *tableView;

@property (assign, nonatomic) NSIndexPath *selectedIndexPath;//单选，当前选中的行

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    _tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width, [UIScreen mainScreen].bounds.size.height) style:UITableViewStyleGrouped]; //Grouped类型的，section头部就不会一直停留在最上面
    _tableView.delegate = self;
    _tableView.dataSource = self;
    _tableView.backgroundColor = [UIColor groupTableViewBackgroundColor];
    [self.view addSubview:_tableView];
    _tableView.rowHeight = 150;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 10;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *cellId = @"cellid";
    SelectedCell *cell = [tableView dequeueReusableCellWithIdentifier:cellId];
    if (cell == nil) {
        cell = [[SelectedCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellId];
    }
    cell.xlDelegate = self;
    cell.selectedIndexPath = indexPath;
  
    [cell.selectedButton setImage:[UIImage imageNamed:@"unSelected"] forState:UIControlStateNormal];
    
    //当上下拉动的时候，因为cell的复用性，我们需要重新判断一下哪一行是打勾的
    if (_selectedIndexPath == indexPath) {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
        //[cell.selectedButton setImage:[UIImage imageNamed:@"selected"] forState:UIControlStateNormal];
        
    }else {
        cell.accessoryType = UITableViewCellAccessoryNone;
        
    }
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    //之前选中的，取消选择
    SelectedCell *celled = [tableView cellForRowAtIndexPath:_selectedIndexPath];
    celled.accessoryType = UITableViewCellAccessoryNone;
    [celled.selectedButton setImage:[UIImage imageNamed:@"unSelected"] forState:UIControlStateNormal];
    celled.xlDelegate = self;
    celled.selectedIndexPath = indexPath;
    //记录当前选中的位置索引
    _selectedIndexPath = indexPath;
    //当前选择的打勾
    SelectedCell *cell = [tableView cellForRowAtIndexPath:indexPath];
    cell.accessoryType = UITableViewCellAccessoryCheckmark;
    [cell.selectedButton setImage:[UIImage imageNamed:@"selected"] forState:UIControlStateNormal];
}

- (void)handleSelectedButtonActionWithSelectedIndexPath:(NSIndexPath *)selectedIndexPath {
    SelectedCell *celled = [_tableView cellForRowAtIndexPath:_selectedIndexPath];
    celled.accessoryType = UITableViewCellAccessoryNone;
    [celled.selectedButton setImage:[UIImage imageNamed:@"unSelected"] forState:UIControlStateNormal];
    celled.xlDelegate = self;
    //记录当前选中的位置索引
    _selectedIndexPath = selectedIndexPath;
    //当前选择的打勾
    SelectedCell *cell = [_tableView cellForRowAtIndexPath:selectedIndexPath];
    cell.accessoryType = UITableViewCellAccessoryCheckmark;
    [cell.selectedButton setImage:[UIImage imageNamed:@"selected"] forState:UIControlStateNormal];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
